; ****************************************************************************
;
;                             L E M M I N G S
;
;                               a ti port by
;
;                 Stephan Effelsberg b012414@dvz.fh-koeln.de
;                 Alejandro Paz Schmidt psys@cotelco.com.ar
;
; Last modification 8/30/00
;
; Level library
;
; ****************************************************************************

;choose one from below
;ti92 equ 1
;ti92plus equ 1
ti89 equ 1

    IFD ti92
        include "tios.h"
    ENDIF
    IFD ti92plus ; [tie] too ;-)
        include "doorsos.h"
        xdef _ti92plus
    ENDIF
    IFD ti89
        include "doorsos.h"
        xdef _ti89
    ENDIF

        xdef    _library
        xdef    lemlvl@0000
        xdef    lemlvl@0001

;*****************************************************

LVLDTAS   equ 30 ; bytes per level of data
MAXLIBLVL equ 7

        EVEN

lemlvl@0000:
        ; input d0 : level 0..maxlvl
        ; d0.b = $ff rtn number of levels

        cmp.b   #$ff,d0
        beq.s   f1_l10
        ;
        ; returns
        ;
        ; A0 : pointer to the packed level data
        ; A1 : pointer to the packed tile data
        ; A2 : pointer to the specific data area
        ; A3 : pointer to the attribute table
        ; D0 : index in the packed level data (to extract level #)
        ; D0 : bits 32..8 destroyed

        cmp.b   #MAXLIBLVL,d0
        bcc     f1_l11
        movem.l d1/d2,-(sp)
        and.w   #$1f,d0          ; up to 32 levels per library
        move.w  d0,d1
        move.w  d0,d2
        mulu    #LVLDTAS,d2
        lea     lvldta(pc),a2
        add.l   d2,a2

        lsr.w   #3,d1   ; index to levelpackeddta
        lsl.w   #1,d1
        move.w  tablvl(pc,d1.w),d1
        lea     levels(pc,d1.w),a0
        lea     tiles(pc),a1
        lea     attribs(pc),a3
        movem.l (sp)+,d1/d2
        rts

f1_l10:
        moveq   #MAXLIBLVL,d0
        rts
f1_l11:
        moveq   #-1,d0
        rts

; last played level
lemlvl@0001:
	dc.w	MAXLIBLVL-1

tablvl  dc.w    0
        dc.w    (l2-levels)
        dc.w    (l3-levels)
        dc.w    (l4-levels)

levels:
        incbin levels.pak
        EVEN
l2:
;       incbin levels2.pak
        EVEN
l3:
;       incbin levels3.pak
        EVEN
l4:
;       incbin levels4.pak
        EVEN

tiles:
        incbin tiles.pak
        EVEN

attribs:
	include "attrib.h"
	EVEN

lvldta:  ; 30 bytes
; level 1
        dc.b    0   ; amount of lemmings of which type
        dc.b    0
        dc.b    0
        dc.b    0
        dc.b    0
        dc.b    0
        dc.b    0
        dc.b    10 ; diggers
        dc.b    5  ; number of lemms needed to exit
        dc.b    10 ; number of lemms total
        dc.b    0  ; nothing
        dc.b    20 ; time spawn

; level life Time (BCD)

        dc.w    $43C  ; 4 mins 60 secs
; comment about the level 16 bytes (15 and zero!)
                ;   just  dig
        dc.b    ':::DOMN::>CA:::',0 ; just dig

; level 2
        dc.b    0   ; amount of lemmings of which type
        dc.b    0
        dc.b    0
        dc.b    0
        dc.b   10  ; floaters w/umbrella
        dc.b    0
        dc.b    0
        dc.b    0
        dc.b    5  ; number of lemms needed to exit
        dc.b   10  ; number of lemms total
        dc.b    0
        dc.b   20

; time

        dc.w    $43C
; message
                ;  just  float
        dc.b    '::DOMN::@FI;N::',0 ; just float

; level 3
        dc.b    5   ; amount of lemmings of which type
        dc.b    5
        dc.b    5
        dc.b    5
        dc.b   10  ; floaters w/umbrella
        dc.b    5
        dc.b    5
        dc.b    5
        dc.b    5  ; number of lemms needed to exit
        dc.b   10  ; number of lemms total
        dc.b    0
        dc.b   20

; time

        dc.w    $43C
; message
        dc.b    ':::::::::::::::',0

; level 4
        dc.b    5   ; amount of lemmings of which type
        dc.b    5
        dc.b    5
        dc.b    5
        dc.b   10  ; floaters w/umbrella
        dc.b    5
        dc.b    5
        dc.b    5
        dc.b    5  ; number of lemms needed to exit
        dc.b   10  ; number of lemms total
        dc.b    0
        dc.b   20

; time

        dc.w    $43c
        dc.b    ':::::::::::::::',0

;level 5
        dc.b    5   ; amount of lemmings of which type
        dc.b    5
        dc.b    5
        dc.b    5
        dc.b   10  ; floaters w/umbrella
        dc.b    5
        dc.b    5
        dc.b    5
        dc.b    5  ; number of lemms needed to exit
        dc.b   10  ; number of lemms total
        dc.b    0
        dc.b   60   ; spawn time

; time

        dc.w    $43c
        dc.b    ':::::::::::::::',0
;level 6
        dc.b    5   ; amount of lemmings of which type
        dc.b    5
        dc.b    5
        dc.b    5
        dc.b   10  ; floaters w/umbrella
        dc.b    5
        dc.b    5
        dc.b    5
        dc.b    5  ; number of lemms needed to exit
        dc.b   10  ; number of lemms total
        dc.b    0
        dc.b   60   ; spawn time

; time

        dc.w    $43c
        dc.b    ':::::::::::::::',0
;level 7
        dc.b    0   ; amount of lemmings of which type
        dc.b    0  ; climber
        dc.b   10  ; builder
        dc.b    5  ; miner
        dc.b    0  ; floater
        dc.b    5  ; blocker
        dc.b   10  ; basher
        dc.b    0  ; digger
        dc.b    5  ; number of lemms needed to exit
        dc.b   10  ; number of lemms total
        dc.b    0
        dc.b  110   ; spawn time

; time

        dc.w    $43c
        dc.b    ':::::::::::::::',0

    IFD ti92
_library        dc.b        "lemlvl",0,0
    ENDIF

        end
